// **********************************************************************
//
// Copyright (c) 2003
// ZeroC, Inc.
// Billerica, MA, USA
//
// All Rights Reserved.
//
// Ice is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License version 2 as published by
// the Free Software Foundation.
//
// **********************************************************************

// Ice version 1.2.0
// Generated from file `D:/ldap2/MVAPLdap.ice'

#include "MVAPLdap.h"
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 10200
#       error Ice version mismatch!
#   endif
#endif

void
IceInternal::incRef(::MVAPLdap::LDAPProxy* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::MVAPLdap::LDAPProxy* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::MVAPLdap::LDAPProxy* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::MVAPLdap::LDAPProxy* p)
{
    p->__decRef();
}

void
IceInternal::checkedCast(const ::Ice::ObjectPrx& b, ::MVAPLdap::LDAPProxyPrx& d)
{
    d = 0;
    if(b.get())
    {
	d = dynamic_cast< ::IceProxy::MVAPLdap::LDAPProxy*>(b.get());
	if(!d && b->ice_isA("::MVAPLdap::LDAPProxy"))
	{
	    d = new ::IceProxy::MVAPLdap::LDAPProxy;
	    d->__copyFrom(b);
	}
    }
}

void
IceInternal::checkedCast(const ::Ice::ObjectPrx& b, const ::std::string& f, ::MVAPLdap::LDAPProxyPrx& d)
{
    d = 0;
    if(b)
    {
	::Ice::ObjectPrx bb = b->ice_appendFacet(f);
	try
	{
	    if(bb->ice_isA("::MVAPLdap::LDAPProxy"))
	    {
		d = new ::IceProxy::MVAPLdap::LDAPProxy;
		d->__copyFrom(bb);
	    }
	}
	catch(const ::Ice::FacetNotExistException&)
	{
	}
    }
}

void
IceInternal::uncheckedCast(const ::Ice::ObjectPrx& b, ::MVAPLdap::LDAPProxyPrx& d)
{
    d = 0;
    if(b)
    {
	d = dynamic_cast< ::IceProxy::MVAPLdap::LDAPProxy*>(b.get());
	if(!d)
	{
	    d = new ::IceProxy::MVAPLdap::LDAPProxy;
	    d->__copyFrom(b);
	}
    }
}

void
IceInternal::uncheckedCast(const ::Ice::ObjectPrx& b, const ::std::string& f, ::MVAPLdap::LDAPProxyPrx& d)
{
    d = 0;
    if(b)
    {
	::Ice::ObjectPrx bb = b->ice_appendFacet(f);
	d = new ::IceProxy::MVAPLdap::LDAPProxy;
	d->__copyFrom(bb);
    }
}

void
MVAPLdap::__write(::IceInternal::BasicStream* __os, const ::MVAPLdap::LDAPProxyPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
MVAPLdap::__read(::IceInternal::BasicStream* __is, ::MVAPLdap::LDAPProxyPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::MVAPLdap::LDAPProxy;
	v->__copyFrom(proxy);
    }
}

void
MVAPLdap::__write(::IceInternal::BasicStream* __os, const ::MVAPLdap::LDAPProxyPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

::Ice::Int
IceProxy::MVAPLdap::LDAPProxy::test()
{
    return test(__defaultContext());
}

::Ice::Int
IceProxy::MVAPLdap::LDAPProxy::test(const ::Ice::Context& __ctx)
{
    int __cnt = 0;
    while(true)
    {
	try
	{__checkTwowayOnly("test");
	    ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase = __getDelegate();
	    ::IceDelegate::MVAPLdap::LDAPProxy* __del = dynamic_cast< ::IceDelegate::MVAPLdap::LDAPProxy*>(__delBase.get());
	    return __del->test(__ctx);
	}
	catch(const ::IceInternal::NonRepeatable& __ex)
	{
	    __handleException(*__ex.get(), __cnt);
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    __handleException(__ex, __cnt);
	}
    }
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::MVAPLdap::LDAPProxy::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::MVAPLdap::LDAPProxy);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::MVAPLdap::LDAPProxy::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::MVAPLdap::LDAPProxy);
}

bool
IceProxy::MVAPLdap::operator==(const ::IceProxy::MVAPLdap::LDAPProxy& l, const ::IceProxy::MVAPLdap::LDAPProxy& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::MVAPLdap::operator!=(const ::IceProxy::MVAPLdap::LDAPProxy& l, const ::IceProxy::MVAPLdap::LDAPProxy& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::MVAPLdap::operator<(const ::IceProxy::MVAPLdap::LDAPProxy& l, const ::IceProxy::MVAPLdap::LDAPProxy& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

::Ice::Int
IceDelegateM::MVAPLdap::LDAPProxy::test(const ::Ice::Context& __context)
{
    static const ::std::string __operation("test");
    ::IceInternal::Outgoing __out(__connection.get(), __reference.get(), __operation, static_cast< ::Ice::OperationMode>(2), __context);
    ::IceInternal::BasicStream* __is = __out.is();
    if(!__out.invoke())
    {
	throw ::Ice::UnknownUserException(__FILE__, __LINE__);
    }
    ::Ice::Int __ret;
    try
    {
	__is->read(__ret);
    }
    catch(const ::Ice::LocalException& __ex)
    {
	throw ::IceInternal::NonRepeatable(__ex);
    }
    return __ret;
}

::Ice::Int
IceDelegateD::MVAPLdap::LDAPProxy::test(const ::Ice::Context& __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, "test", static_cast< ::Ice::OperationMode>(2), __context);
    while(true)
    {
	::IceInternal::Direct __direct(__current);
	::MVAPLdap::LDAPProxy* __servant = dynamic_cast< ::MVAPLdap::LDAPProxy*>(__direct.facetServant().get());
	if(!__servant)
	{
	    ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
	    __opEx.id = __current.id;
	    __opEx.facet = __current.facet;
	    __opEx.operation = __current.operation;
	    throw __opEx;
	}
	try
	{
	    return __servant->test(__current);
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    throw ::IceInternal::NonRepeatable(__ex);
	}
    }
}

const ::std::string MVAPLdap::LDAPProxy::__ids[2] =
{
    "::Ice::Object",
    "::MVAPLdap::LDAPProxy"
};

bool
MVAPLdap::LDAPProxy::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__ids, __ids + 2, _s);
}

::std::vector< ::std::string>
MVAPLdap::LDAPProxy::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__ids[0], &__ids[2]);
}

const ::std::string&
MVAPLdap::LDAPProxy::ice_id(const ::Ice::Current&) const
{
    return __ids[1];
}

const ::std::string&
MVAPLdap::LDAPProxy::ice_staticId()
{
    return __ids[1];
}

void
MVAPLdap::LDAPProxy::__gcReachable(::IceUtil::GCObjectMultiSet& _c) const
{
#if defined(_MSC_VER) && (MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__gcReachable(_c);
#else
    ::Ice::Object::__gcReachable(_c);
#endif
}

void
MVAPLdap::LDAPProxy::__gcClear()
{
#if defined(_MSC_VER) && (MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__gcClear();
#else
    ::Ice::Object::__gcClear();
#endif
}

::IceInternal::DispatchStatus
MVAPLdap::LDAPProxy::___test(::IceInternal::Incoming& __in, const ::Ice::Current& __current)
{
    ::IceInternal::BasicStream* __os = __in.os();
    ::Ice::Int __ret = test(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::std::string MVAPLdap::LDAPProxy::__all[] =
{
    "ice_facets",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "test"
};

::IceInternal::DispatchStatus
MVAPLdap::LDAPProxy::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__all, __all + 6, current.operation);
    if(r.first == r.second)
    {
	return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __all)
    {
	case 0:
	{
	    return ___ice_facets(in, current);
	}
	case 1:
	{
	    return ___ice_id(in, current);
	}
	case 2:
	{
	    return ___ice_ids(in, current);
	}
	case 3:
	{
	    return ___ice_isA(in, current);
	}
	case 4:
	{
	    return ___ice_ping(in, current);
	}
	case 5:
	{
	    return ___test(in, current);
	}
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
MVAPLdap::LDAPProxy::__write(::IceInternal::BasicStream* __os, bool __marshalFacets) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os, __marshalFacets);
#else
    ::Ice::Object::__write(__os, __marshalFacets);
#endif
}

void
MVAPLdap::LDAPProxy::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is);
#else
    ::Ice::Object::__read(__is);
#endif
}

void 
::MVAPLdap::__patch__LDAPProxyPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::MVAPLdap::LDAPProxyPtr* p = static_cast< ::MVAPLdap::LDAPProxyPtr*>(__addr);
    assert(p);
    *p = ::MVAPLdap::LDAPProxyPtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::MVAPLdap::LDAPProxy::ice_staticId();
	throw e;
    }
}

bool
MVAPLdap::operator==(const ::MVAPLdap::LDAPProxy& l, const ::MVAPLdap::LDAPProxy& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
MVAPLdap::operator!=(const ::MVAPLdap::LDAPProxy& l, const ::MVAPLdap::LDAPProxy& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
MVAPLdap::operator<(const ::MVAPLdap::LDAPProxy& l, const ::MVAPLdap::LDAPProxy& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
